// C Source File
// Created 29/08/2004; 12:38:33

#include <tigcclib.h>
#include "mode7.h"

INT_HANDLER save_int_1;

void modif()
{
	m7_Rotate(1);
	if(_keytest (RR_ESC))
		m7_LoopQuit();
}

// Main Function
void _main(void)
{
	register unsigned short i;
	Map m;
	m.dimX = 256;
	m.dimY = 256;
	m.map = NULL;
	m.map0 = (unsigned char *)calloc(256*32,sizeof(unsigned char));
	m.map1 = (unsigned char *)calloc(256*32,sizeof(unsigned char));

	clrscr();
	printf_xy(50,50,"loading...");

	for(i=0;i<256*32;i++)
	{
			if (i%(32*8) < 64)
				m.map0[i]=0xFF;				
	}

	for(i=0;i<256*32;i++)
	{
			m.map1[i] = 0x03;			
	}


	m7_Init(9, 60, 30);
	
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);

	m7_GrayInit();

	m7_SetCameraPos(128 << ZOOM, 128 << ZOOM);

	m7_SetMap(&m);
	
	m7_SetLoopFunc(modif);
	
	m7_LoopInit();
	m7_MainLoop();
	m7_LoopEnd();

	m7_GrayEnd();

	SetIntVec (AUTO_INT_1, save_int_1);

	m7_End();
	free (m.map0);
	free (m.map1);
}
