// Header File
// Created 02/08/2004; 22:25:46

#ifndef ARCH_H
#define ARCH_H

typedef struct ARCH
{
	FILE * archfile;
	unsigned short sublvl;
	unsigned short set;
	unsigned short apos;
	unsigned short size;
}ARCH;

ARCH * afopen (const char *filename); // open a file in "rb" and give an ARCH pointer to the entire archive
ARCH * aopen (ARCH * arch, const char * subfilename); // open a file named subfilename in an opened arch file (sub level of imbrication)
void aclose (ARCH * arch); // close an opened arch file
unsigned short aread (void * ptr, unsigned short size, unsigned short n, ARCH * arch); // like fread but in arch files
short aseek (ARCH * arch, short offset, short whence); // like fseek but in arch files

#endif
