// C Source File
// Created 28/07/2004; 17:10:00

#include <tigcclib.h>


#define put(b) { byte = b; fwrite (&byte, 1, 1, spritefile); }

#define FILENAME "blueflcn"

// Main Function
void _main(void)
{
	FILE * spritefile;
	FILE * imgdatafile;
	register unsigned short i, j;
	unsigned char * tmp;
	unsigned short imgsize, Vsize;
	
	unsigned short nbplanes = 2;
	unsigned short nbscales = 4;
	unsigned short nbimg = 24;
	unsigned short nbanim = 1;
	unsigned short nbdir = 8;
	unsigned short nbimganim[] = {1};
	unsigned short scaledsizes[] = {1,5,2,10,3,15,4,20};
	char data[] = {0,2,3,5,6,8,9,11,12,14,15,17,18,20,21,23,-1};
	const unsigned char * imgdatafilenames[] = {"bf08x05", "bf16x10", "bf24x15", "bf32x20"};
	
	unsigned char byte;
	
	spritefile = fopen (FILENAME, "wb");
	
	fwrite (&nbplanes, sizeof(short), 1, spritefile);
	fwrite (&nbscales, sizeof(short), 1, spritefile);
	fwrite (&nbimg, sizeof(short), 1, spritefile);
	fwrite (&nbanim, sizeof(short), 1, spritefile);
	fwrite (&nbdir, sizeof(short), 1, spritefile);

	// nbimganim
	for (i = 0; i < nbanim; i++)
		fwrite (&(nbimganim[i]), sizeof(short), 1, spritefile);

	// scaledsizes (x: 8 pix step, y)
	for (i = 0; i < (2 * nbscales); i++)
		fwrite (&(scaledsizes[i]), sizeof(short), 1, spritefile);

	// data
	
	i = 0;
	while (data[i] != -1)
	{
		put(data[i]);
		i++;
	}

	// imgdata
	
	if(nbplanes == 2)
		nbimg /= 3;
	else
		nbimg /= 2;
	
	for (i = 0; i < nbscales; i++)
	{
		imgdatafile = fopen (imgdatafilenames[i], "rb");
		fseek(imgdatafile, 4, SEEK_SET);
		fread(&Vsize, sizeof(short), 1, imgdatafile);
		
		imgsize = scaledsizes[i*2] * scaledsizes[(i*2)+1];
		tmp = (unsigned char *)malloc(imgsize * sizeof(unsigned char));


		for (j = 0; j < nbimg * 2; j+=2)
		{
			fseek(imgdatafile, 8 + (j*imgsize), SEEK_SET);
			fread(tmp, sizeof(unsigned char), imgsize, imgdatafile);
			fwrite(tmp, sizeof(unsigned char), imgsize, spritefile);

			if(nbplanes == 2)
			{
				fseek(imgdatafile, 12 + (Vsize*scaledsizes[i*2]) + (j * imgsize), SEEK_SET);
				fread(tmp, sizeof(unsigned char), imgsize, imgdatafile);
				fwrite(tmp, sizeof(unsigned char), imgsize, spritefile);
			}
	
			fseek(imgdatafile, 8 + ((j+1)*imgsize), SEEK_SET);
			fread(tmp, sizeof(unsigned char), imgsize, imgdatafile);
			fwrite(tmp, sizeof(unsigned char), imgsize, spritefile);
		}

		free (tmp);
		fclose (imgdatafile);
	}
	fputc (0, spritefile);
	fputs ("SPRT", spritefile);
	fputc (0, spritefile);
	fputc (OTH_TAG, spritefile);
	fclose (spritefile);
}






