// C Source File
// Created 02/08/2004; 19:34:04

#include <tigcclib.h>
#define BUFFER_SIZE 1024

// Main Function
void _main(void)
{
	register short i;
	FILE * arch;
	FILE * fic;
	unsigned short pos, pos_header_end;
	unsigned char ficname[9];
	unsigned short ficname_length;
	unsigned short fic_length;
	unsigned short fic_pos = 1;
	unsigned char nbfic = 0;
	unsigned char * buff;
	unsigned short buff_length;
	char erreurs = 0;
  ESI argptr;
  int argtype;

  InitArgPtr (argptr);
  if ((argtype = GetArgType (argptr)) == END_TAG)
  	return;
	if (argtype != STR_TAG)
		return;
	if ((arch = fopen (GetStrnArg (argptr), "w+b")) == NULL)
		return;
	fwrite (&nbfic, sizeof(unsigned char), 1, arch);

	if ((buff = (unsigned char *)malloc(sizeof(unsigned char) * BUFFER_SIZE)) == NULL)
	{
		fclose (arch);
		return;		
	}

	while ((argtype = GetArgType (argptr)) != END_TAG)
	{
		if (argtype == STR_TAG)
		{
			strncpy (ficname, GetStrnArg (argptr), 8);
			ficname[8] = 0;
			ficname_length = strlen (ficname);
			if ((fic = fopen (ficname, "rb")))
			{
				nbfic++;
				fseek (fic, 0, SEEK_END);
				fic_length = (unsigned short)ftell (fic);
				fwrite (&fic_pos, sizeof(unsigned short), 1, arch);
				fwrite (&fic_length, sizeof(unsigned short), 1, arch);
				fwrite (ficname, sizeof(unsigned char), ficname_length + 1, arch);
				fclose (fic);
			}
			else
				erreurs = 1;
		}
		else
			erreurs = 1;
	}
	
	
	fic_pos = pos_header_end = (unsigned short)ftell (arch);
	pos = 1;
	fseek (arch, 0, SEEK_SET);
	fwrite (&nbfic, sizeof(unsigned char), 1, arch);


	while (pos < pos_header_end)
	{
		fseek (arch, pos, SEEK_SET);
		fwrite (&fic_pos, sizeof(unsigned short), 1, arch);
		
		fread (&fic_length, sizeof(unsigned short), 1, arch);
		fic_pos +=fic_length;
		for(i = 0; i < 8; i++)
		{
			fread (&(ficname[i]), sizeof(unsigned char), 1, arch);
			if (ficname[i] == 0)
				break;
		}
		
		if (i == 8)
			fseek (arch, 1, SEEK_CUR);
			
		pos = (unsigned short)ftell (arch);
		fseek (arch, 0, SEEK_END);
		ficname[i] = 0;
		
		fic = fopen (ficname, "rb");
		
		while ((buff_length = fread (buff, sizeof(unsigned char), BUFFER_SIZE, fic)))
		{
			fwrite (buff, sizeof(unsigned char), buff_length, arch);
		}
		fclose (fic);
			
				
	}


	free (buff);
	fputc (0, arch);
	fputs ("ARCH", arch);
	fputc (0, arch);
	fputc (OTH_TAG, arch);
	fclose (arch);

	if (erreurs)
	{
		ST_showHelp ("An error occured during this operation");
		ngetchx();
	}
}
