// C Source File
// Created 25/01/2003; 21:20:38
#include <tigcclib.h>
#include "kbd.h"

unsigned short Keys[9]={0,0,0,0,0,0,0,0,0};
unsigned short Repeat_Keys[9]={0,0,0,0,0,0,0,0,0};
INT_HANDLER save_int_1;
INT_HANDLER save_int_6;

void kbd_Scan()
{
	unsigned char column;
	register unsigned short i;
	unsigned char mask;
	column = _rowread (0xFFFE);
	mask = 0x8;
	for(i=0;i<5;i++)
	{
		if(column & mask)
			Keys[i]=1;
		else
			Keys[i]=0;
		mask = mask<<1;
	}
	column = _rowread (0xFFBF);
	if(column & 0x10) Keys[5] = 1;
	else  Keys[5] = 0;
	if(column & 0x40) Keys[7] = 1;
	else  Keys[7] = 0;
	if((_rowread (0xFDFF)) & 0x8) Keys[6] = 1;
	else  Keys[6] = 0;
	if((_rowread (0xFEFF)) & 0x40) Keys[8] = 1;
	else  Keys[8] = 0;
}

void kbd_Repeat()
{
	register unsigned short i;

	kbd_Scan();
	for(i=0;i<9;i++)
	{
		if((Keys[i] == 0) || Repeat_Keys[i] == REPEAT)
			Repeat_Keys[i]=0;
		else
			Repeat_Keys[i]++;
	}
}

void kbd_Init()
{
	save_int_1 = GetIntVec (AUTO_INT_1); // auto int 1 off
	save_int_6 = GetIntVec (AUTO_INT_6);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec (AUTO_INT_6, DUMMY_HANDLER); // auto int 6 off
}

void kbd_End()
{
	SetIntVec (AUTO_INT_1, save_int_1); // auto int 1 on
	SetIntVec (AUTO_INT_6, save_int_6); // auto int 6 on
}
