// C Source File
// Created 29/08/2004; 12:38:33

#include <tigcclib.h>
#include "mode7.h"
#include "arch.h"

INT_HANDLER save_int_1;

void modif()
{
	if(_keytest (RR_LEFT))
		m7_Rotate(1);
	if(_keytest (RR_RIGHT))
		m7_Rotate(-1);
	if(_keytest (RR_UP))
		m7_TranslateDir(3);
	if(_keytest (RR_DOWN))
		m7_TranslateDir(-3);


	if(_keytest (RR_ESC))
		m7_LoopQuit();

}

// Main Function
void _main(void)
{
	register unsigned short i;
	ARCH * data;
	unsigned short id;
	Map * sky;
	Map m;
	m.dimX = 256;
	m.dimY = 256;
	m.map = NULL;
	m.map0 = (unsigned char *)calloc(256*32,sizeof(unsigned char));
	m.map1 = (unsigned char *)calloc(256*32,sizeof(unsigned char));

	data = afopen("data");

	id = m7sprites_AddSprite (m7sprites_LoadSprite(data, "sprite"));

	AllSpriteList[id]->x = 128 << ZOOM;
	AllSpriteList[id]->y = 115 << ZOOM;
	

	clrscr();
	printf_xy(50,50,"loading...");

	for(i=0;i<256*32;i++)
	{
			if (i%(32*8) < 64)
				m.map0[i]=0xFF;				
	}

	for(i=0;i<256*32;i++)
	{
			m.map1[i] = 0x03;			
	}

	sky = map_Load(data, data, "sky", "skytile");

	m7_Init(9, 60, 30);
	
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);

	m7_GrayInit();

	m7_SetCameraPos(128 << ZOOM, 128 << ZOOM);

	m7_SetDir (64);

	m7_SetMap(&m);
	m7_SetSky(sky->map0, sky->map1);
	
	m7_SetLoopFunc(modif);
	
	m7_LoopInit();
	m7_MainLoop();
	m7_LoopEnd();

	m7sprites_RemoveAllSprites();
	m7sprites_FreeAllSprite();

	m7_GrayEnd();

	SetIntVec (AUTO_INT_1, save_int_1);

	m7_End();
	aclose(data);
	free (m.map0);
	free (m.map1);
	map_Free(sky);
}
