// C Source File
// Created 14/03/2004; 15:01:05

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
	// Convert picture file imgtiles created with picmaker into a tiles file (do not use with 7 gray level)
	// (because I don't know	how to make directly .89e files from .bmp files)
	// tiles need to be square
	
	
	register short i;
	FILE * imgtiles;
	FILE * tiles;
	short nbPlans;
	short sizeH;
	short sizeV;
	short nbTiles;
	unsigned char * tmp;
	
	if((imgtiles = fopen ("main\\imgtiles", "rb")))
	{
		tiles = fopen("main\\tiles","wb");
	
		fseek(imgtiles, 2, SEEK_SET);
		fread(&nbPlans, sizeof(short), 1, imgtiles);
		fread(&nbTiles, sizeof(short), 1, imgtiles);
		fread(&sizeH, sizeof(short), 1, imgtiles);
		sizeV = sizeH * 8;
		nbTiles /= sizeV;
		fwrite (&nbPlans, sizeof(short), 1, tiles); 
		fwrite (&nbTiles, sizeof(short), 1, tiles); 
		fwrite (&sizeH, sizeof(short), 1, tiles); 
		fwrite (&sizeV, sizeof(short), 1, tiles); 
	
		tmp = (unsigned char *)malloc(sizeH * sizeV * sizeof(unsigned char));
	
		for(i=0;i<nbTiles;i++)
		{
			fseek(imgtiles, 8 + (i * sizeH * sizeV), SEEK_SET);
			fread(tmp, sizeof(unsigned char), sizeH * sizeV, imgtiles);
			fwrite(tmp, sizeof(unsigned char), sizeH * sizeV, tiles);
			if(nbPlans == 2)
			{
				fseek(imgtiles, 12 + ((i+(nbTiles)) * sizeH * sizeV), SEEK_SET);
				fread(tmp, sizeof(unsigned char), sizeH * sizeV, imgtiles);
				fwrite(tmp, sizeof(unsigned char), sizeH * sizeV, tiles);
			}
		}
	
		free(tmp);
	
		fputc (0, tiles);
		fputs ("TILE", tiles);
		fputc (0, tiles);
		fputc (OTH_TAG, tiles);
		fclose(imgtiles);
		fclose(tiles);
	}
	else
	{
		ST_showHelp ("ERROR : NO INPUT FILE : imgtiles");
		ngetchx();		
	}
		
}
